/*****************************************************************************\
|* 
|* C++ visualisation app for the IP space we have mapped to cities.
|* 
|* Author						: SjG
|* First created				: Sat Nov  8 13:55:51 GMT 2003
|* Modification history			: <none>
|* Tabstops						: 4
|* Licence						: GPL, See COPYING for details
|*
|*    This program is free software; you can redistribute it and/or modify
|*    it under the terms of the GNU General Public License as published by
|*    the Free Software Foundation; either version 2 of the License, or
|*    (at your option) any later version.
|*
|*    This program is distributed in the hope that it will be useful,
|*    but WITHOUT ANY WARRANTY; without even the implied warranty of
|*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|*    GNU General Public License for more details.
|*
|*    You should have received a copy of the GNU General Public License
|*    along with this program; if not, write to the Free Software
|*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
|*
\*****************************************************************************/

#include <cstring>      // Daniel K. O.
#include <cstdlib>      // Daniel K. O.

#include "cmdLine.h"

using namespace std;    // by Daniel K. O.

// ===========================================================================
// Constructor
// ===========================================================================
cmdlineArgs::cmdlineArgs(int argc, char **argv)
	{
	_num  = argc;
	_args = argv;
	}

// ===========================================================================
// Method - return a string from the arguments
// ===========================================================================
char * cmdlineArgs::getString(char *small, char *large, char *fallback)
	{
	for (int i=0; i<_num-1; i++)
		if (strcmp(_args[i], small) == 0 || strcmp(_args[i], large) == 0)
			return _args[i+1];
	
	return fallback;
	}
	

// ===========================================================================
// Method - return a string from the arguments
// ===========================================================================
int cmdlineArgs::getInt(char *small, char *large, int fallback)
	{
	for (int i=0; i<_num-1; i++)
		if (strcmp(_args[i], small) == 0 || strcmp(_args[i], large) == 0)
			return atoi(_args[i+1]);
	
	return fallback;
	}
	

// ===========================================================================
// Method - return a float from the arguments
// ===========================================================================
float cmdlineArgs::getFloat(char *small, char *large, float fallback)
	{
	for (int i=0; i<_num-1; i++)
		if (strcmp(_args[i], small) == 0 || strcmp(_args[i], large) == 0)
			return atof(_args[i+1]);
	
	return fallback;
	}

// ===========================================================================
// Method - return whether a flag is present
// ===========================================================================
int cmdlineArgs::getFlag(char *small, char *large)
	{
	for (int i=0; i<_num; i++)
		if (strcmp(_args[i], small) == 0 || strcmp(_args[i], large) == 0)
			return 1;
	
	return 0;
	}

// ===========================================================================
// Method - return the number of arguments
// ===========================================================================
int cmdlineArgs::getNum(void)
	{
	return _num;
	}
	
	

// ===========================================================================
// Method - return a string from the arguments
// ===========================================================================
char ** cmdlineArgs::getArray(char *small, char *large, int *num)
	{
	char **list = new char*[_num];
	*num = 0;
	
	for (int i=0; i<_num-1; i++)
		if (strcmp(_args[i], small) == 0 || strcmp(_args[i], large) == 0)
			{
			list[*num] = _args[i+1];
			*num = *num +1;
			}
	
	return list;
	}
	

// ===========================================================================
// Method - remove an argument
// ===========================================================================
bool cmdlineArgs::remove(char *arg, int num)
	{
	for (int i=1; i<_num-num; i++)
		if (strcmp(_args[i], arg) == 0)
			{
			for (int j=0; j<num; j++)
				strcpy(_args[i+j], "");
			return true;
			}
		
	return false;
	} 
